//+------------------------------------------------------------------+
//|                                                      Player5.mqh |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
//+------------------------------------------------------------------+
//| #include <Player5.mqh>                                           |
//+------------------------------------------------------------------+
#include "Player5_1.mqh" 
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
class CPlayer
  {
private:
   bool              delete_charts;//   
   int               value_of_division;//       1   
   int               speed_limit;
   int               staticprogress;// 
   double            open;         //  
   double            high;         //    
   double            low;          //    
   double            close;        //  
   CTable           *table;        //   
   CRulerData       *rb;
   CRulerTF         *rul_m1;  //   1  
   CRuler           *rul_curr;//                                  
   CSpeed           *speedo;  //  
   CProgress        *progr;   //  
   CPlay            *plays;   //  /
   CClick           *click;   //   
   CBackGround      *bg;      //    
   CBarDraw         *b_draw;  //    
   CHistoryDraw     *h_draw;  //     
   void              DrawingBar(datetime time,double &o,double &h,double &l,double &c);   
public:
   long              chart_id;// ID- 
   CChartData        data;    //  
   SBase             sb;      //        

                     CPlayer()// 
     {
      chart_id=-1;
      open=0;high=0;low=0;close=0;
      staticprogress=0;
     };
                    ~CPlayer()// 
     {//   
      delete rb;
      delete rul_curr;
      delete rul_m1;
      delete h_draw;
      delete b_draw;
      delete bg;
      delete click;
      delete plays;
      delete progr;
      delete speedo;
      //       
      if(delete_charts)ChartClose(chart_id);
     };
   void              Create(CTable *table_,
                            long Chart_id,
                            CChartData *data_,
                            datetime beg_time,
                            datetime end_time,
                            ENUM_TIMEFRAMES period_gen_,
                            int speed_limit_,
                            bool delete_charts_,
                            int Size_button);
   bool              EventClick(){return(click.Update());};//   
   void              CheckPeriod(ENUM_TIMEFRAMES &per_gen);//   
   void              Update();                             //  
   datetime          Progress(datetime time);              //   
   void              Copy(CPlayer *base);                  //     
   void              Navigate(datetime time);              //    
   void              Draw(datetime time);                  //   
  };
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void CPlayer::Create(CTable *table_,
                     long Chart_id,
                     CChartData *data_,
                     datetime begtime,
                     datetime endtime,
                     ENUM_TIMEFRAMES period_gen_,
                     int speed_limit_,
                     bool delete_charts_,
                     int Size_button
                     )

  {
//        
// , , ., , , ., , ,    .
//   0     1      2        3      4        5         6        7           8
   chart_id=Chart_id;
   __LAST_ERR_CHART_WRONG_ID_void__
   table=table_;
   delete_charts=delete_charts_;
   speed_limit=speed_limit_+1;

   ChartSetInteger(chart_id,CHART_AUTOSCROLL,false);
   ChartSetInteger(chart_id,CHART_SHOW_ASK_LINE,false);
   ChartSetInteger(chart_id,CHART_SHOW_BID_LINE,false);
   ChartSetInteger(chart_id,CHART_SHOW_LAST_LINE,false);
   ChartSetInteger(chart_id,CHART_SHOW_OHLC,false);

   data.ApplyTemplate(chart_id,data_);

   sb.time=begtime;
   sb.speed=speed_limit-1;

   rul_curr=new CRuler();
   rul_curr.Create(chart_id,GetPointer(sb),GetPointer(data),begtime,endtime,data.period); //    

   rb=new CRulerData();
   rb.CRulerDataInit(ChartSymbol(chart_id),begtime,endtime);
   rul_m1=new CRulerTF();
   rul_m1.Init(GetPointer(rb));
   ENUM_TIMEFRAMES pg=period_gen_;
   CheckPeriod(pg);
   rul_m1.CRulerTFInit(pg,begtime,endtime);//   1  
   sb.period_gen=rul_m1.Period();
   bg=new CBackGround(); bg.Create(chart_id,GetPointer(sb),GetPointer(data));                   //    
   b_draw=new CBarDraw(); b_draw.Create(chart_id,GetPointer(sb),GetPointer(data));              //    

   speedo=new CSpeed(); speedo.Create(chart_id,GetPointer(sb),GetPointer(data),speed_limit);    //  
   progr=new CProgress(); progr.Create(chart_id,GetPointer(sb),GetPointer(data),Size_button);   //  
   plays=new CPlay(); plays.Create(chart_id,GetPointer(sb),GetPointer(data));                   //  /
   click=new CClick(); click.Create(chart_id,GetPointer(sb),GetPointer(data));                  //   
   h_draw=new CHistoryDraw(); h_draw.Create(table_,chart_id,GetPointer(sb),GetPointer(data));   //    
                                                                                                      
   value_of_division=rul_m1.Area()/sb.progress_count;//    
  }
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
void CPlayer::Update()
  {
   __LAST_ERR_CHART_WRONG_ID_void__
   data.Update(chart_id);
//  play,progress,speed
   plays.Update();    //  /
   speedo.Update();   //  
   progr.Update();    //   

   rul_curr.Update(data.period); //    CURRENT
   CheckPeriod(sb.period_gen);   //   
   rul_m1.Update(sb.period_gen); //    M1     
   value_of_division=rul_m1.Area()/sb.progress_count;//    
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void CPlayer::CheckPeriod(ENUM_TIMEFRAMES &per_gen)
  {
   __LAST_ERR_CHART_WRONG_ID_void__
   //       TFarray
   int t=SerchTFLess(per_gen); per_gen=TFarray[t];
   //  ,         
   if(MinuteTF(data.period)<=MinuteTF(per_gen))
     {//   
      int temp=SerchTF(data.period);
      while(MinuteTF(per_gen)>MinuteTF(data.period)/2)
        {
         if(temp>0)
           {
            per_gen=TFarray[temp--];
           }
         else {per_gen=TFarray[0]; break;}
        }
     }
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
datetime CPlayer::Progress(datetime time)
  {
   __LAST_ERR_CHART_WRONG_ID__
   datetime new_time=rul_m1.CastToCurr(time);//     

//---      
   if(sb.progress!=staticprogress)
     {//---     
      staticprogress=sb.progress;
      new_time=rul_m1.TimeByBars(staticprogress*value_of_division);
     }
//---        
   if(sb.play)
     {
      if(sb.state)sb.tackt++;//   
      if(sb.tackt%((speed_limit-sb.speed)*4)==0)//  4-    
        {
         //  
         new_time=rul_m1.NextTime(new_time);
         //---     
         if(sb.progress==staticprogress)
           {
            if(value_of_division!=0)
               progr.SetState(rul_m1.BarsByTime(new_time)/value_of_division);
           }
        }
     }
//---    , .       
   datetime time_bar=rul_curr.CastToCurr(new_time);
   if(sb.time_bar!=time_bar)
     {
      sb.time_bar=time_bar;
      sb.new_bar=true;
     }
   return(new_time);
  }
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void CPlayer::Copy(CPlayer *base)
  {
   __LAST_ERR_CHART_WRONG_ID_void__
   data.ApplyTemplate(chart_id,GetPointer(base.data));
   sb.Copy(GetPointer(base.sb));
   Update();
  }
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void CPlayer::Draw(datetime time)
  {
   __LAST_ERR_CHART_WRONG_ID_void__
   if(sb.play)
     {
      int spd=speed_limit-sb.speed;
      if(sb.tackt%spd==0)
        {
         if(sb.new_bar)
           {
            datetime temp_time=sb.time_bar;
            rul_m1.BarsByTime_Set(temp_time);
            open=rul_m1.open[rul_m1.bar];
            high=open; low=open; close=open;
            while(!IsStopped() && temp_time<time)//   ,   
              {
               DrawingBar(temp_time,open,high,low,close);
               temp_time=rul_m1.NextTime(temp_time);
              }
           }
         DrawingBar(time,open,high,low,close);

         int schift=rul_curr.Schift();
         int bar=schift-rul_curr.BarsByTime(sb.time_bar);
         datetime temp_time=sb.time_bar;
         if(sb.new_bar){bar++;temp_time=rul_curr.NextTime(temp_time);}

         datetime time_prev=rul_curr.PrevTime(sb.time_bar);
         double close_prev[];CopyClose(ChartSymbol(chart_id),ChartPeriod(chart_id),time_prev,1,close_prev);
         double opens[];CopyOpen(ChartSymbol(chart_id),ChartPeriod(chart_id),sb.time_bar,1,opens);

         b_draw.Update(bar,temp_time,time_prev,close_prev[0],opens[0],high,low,close);
        }
     }
   if(h_draw.state)h_draw.Update(time,close);
   b_draw.Comments(open,high,low,close);
  };
//+------------------------------------------------------------------+
//|      Draw(datetime time)          |
//|                                             |
//+------------------------------------------------------------------+
void CPlayer::DrawingBar(datetime time,double &o,double &h,double &l,double &c)
  {
   __LAST_ERR_CHART_WRONG_ID_void__
   b_draw.timeM1=time;
   int cnt=rul_m1.BarsByTime(time);
   if(cnt>=rul_m1.size-2)cnt=rul_m1.size-2;        
//---
   int spd=speed_limit-sb.speed;
   int tackt_draw=(int)((sb.tackt%(spd*4))/spd);
   double temp_price;
   switch(tackt_draw)
     {
      case 0: temp_price=rul_m1.open[cnt]; break;
      case 1: temp_price=rul_m1.open[cnt]>rul_m1.close[cnt]?rul_m1.high[cnt]:rul_m1.low[cnt]; break;
      case 2: temp_price=rul_m1.open[cnt]>rul_m1.close[cnt]?rul_m1.low[cnt]:rul_m1.high[cnt]; break;
      case 3: temp_price=rul_m1.close[cnt];
      if(cnt>=rul_m1.size-2)
        {
         plays.Set_Play(false);
         if(temp_price==-EMPTY_VALUE){temp_price=c;}
        }
      break;
      default: temp_price=rul_m1.close[cnt]; break;
     }

   h=fmax(high,temp_price);
   l=fmin(low,temp_price);
   c=temp_price;
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void CPlayer::Navigate(datetime time)
  {
   __LAST_ERR_CHART_WRONG_ID_void__
//      
   int schift=rul_curr.Schift();
   int bar=schift-rul_curr.BarsByTime(time);
   if(sb.new_bar){ if(sb.play)sb.new_bar=false; bg.Update(bar+1);}
   else bg.Update(bar);
   ChartNavigate(chart_id,CHART_END,-(bar));
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
