//+------------------------------------------------------------------+
//|                                                        Ruler.mqh |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
//+------------------------------------------------------------------+
//| #include <Ruler.mqh>                                             |
//+------------------------------------------------------------------+
class CSearchArray
  {
private:
   int               QuickSearch(datetime element);//  
   int               SearchLess(datetime element); //     
protected:
   //int               cnt;
   int               step;    //     2^step //   
   int               reserved;//   
public:
   datetime          time[];  //  
   double            open[];  //--//
   double            high[];  //--//
   double            low[];   //--//
   double            close[]; //--//
   int               size;    //  
                     CSearchArray(void);
                    ~CSearchArray(void){};
   void              Free();                             //  ,  
   int               Resize(int size);                   //   
   int               SearchLessOrEqual(datetime element);//       
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CSearchArray::CSearchArray(void)
  {
//cnt=0;
   step=5;//      2^step
   reserved=0;
   size=0;
   Resize(0);
  }
//+------------------------------------------------------------------+
//|  ,                             |
//+------------------------------------------------------------------+
void CSearchArray::Free()
  {
   size=0; reserved=0;
   ArrayFree(time);
   ArrayFree(open);
   ArrayFree(high);
   ArrayFree(low);
   ArrayFree(close);
  };
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
int CSearchArray::Resize(int size_)
  {
   size=size_;
   if((size>>step<<step)<reserved)
     {
      ArrayResize(time,size);
      ArrayResize(open,size);
      ArrayResize(high,size);
      ArrayResize(low,size);
      ArrayResize(close,size);
     }
   else
     {
      reserved=((size>>step)+1)<<step;
      int new_reserv=reserved-size;//          
      ArrayResize(time,size,new_reserv);
      ArrayResize(open,size,new_reserv);
      ArrayResize(high,size,new_reserv);
      ArrayResize(low,size,new_reserv);
      ArrayResize(close,size,new_reserv);
     }
   return(size);
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
int CSearchArray::QuickSearch(datetime element)
  {
   int  i,j,m=-1;
   datetime temp;
//--- search
   i=0;
   j=size-1;
   while(j>=i)
     {
      //--- ">>1" is quick division by 2
      m=(j+i)>>1;
      if(m<0 || m>=size) break;
      temp=time[m];
      if(temp==element) break;
      if(temp>element)  j=m-1;
      else              i=m+1;
     }
//---
   return(m);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CSearchArray::SearchLess(datetime element)
  {
   int pos;
//--- checking   
   if(size==0) return(-1);
   if(time[0]==element)return(0);
//--- searching
   pos=QuickSearch(element);

   while(time[pos]>=element)
      if(pos--==0) return(-1);
//---
   return(pos);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CSearchArray::SearchLessOrEqual(datetime element)
  {
   int pos=SearchLess(element);

//--- searching
   if(pos!=-1)
     {
      if(pos!=size-1 && time[pos+1]==element) return(pos+1);
      else                                    return(pos);
     }
//---
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CRulerData : public CSearchArray
  {
public:
   string            symbol;// 
   datetime          beg;   // 
   datetime          end;   // 
                     CRulerData(void){};
                    ~CRulerData(void){};
   //---    //  
   int               CRulerDataInit(string symbol,datetime beg_,datetime end_);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CRulerData::CRulerDataInit(string symbol_,datetime beg_,datetime end_)
  {
   beg=beg_; end=end_; symbol=symbol_; //     
   int count=Bars(symbol,PERIOD_M1,beg,end);//   
//---   
   int ff=0;
   while(!IsStopped() && count<=0)//  
     {
      count=Bars(symbol,PERIOD_M1,beg,end);
      if(count>0)break;
      Sleep(10);
      //        
      ff++; if(ff>600){Print("_    "+symbol);ExpertRemove(); break;}
     }

   MqlRates temp[];//       
   Resize(CopyRates(symbol,PERIOD_M1,end,count,temp));
   
   time[0]=temp[0].time;
   open[0]=temp[0].open;
   high[0]=temp[0].high;
   low[0]=temp[0].low;
   close[0]=temp[0].close;
   int j=1;
   int Sizes=size;
   for(int i=1;i<Sizes;i++)
     {
      long raz=(long)temp[i].time-
      (long)time[j-1];
      if( raz>60 && raz<3600 )
        {
         size++; Resize(size);
         time[j]=(datetime)(time[j-1]+60);
         open[j]=close[j-1];
         high[j]=close[j-1];
         low[j]=close[j-1];
         close[j]=close[j-1];         
         i--;if(i<1)i=1;         
        }
      else
        {
         time[j]=temp[i].time;
         open[j]=temp[i].open;
         high[j]=temp[i].high;
         low[j]=temp[i].low;
         close[j]=temp[i].close;
        }        
      j++;
     }
     
   ArrayFree(temp);
   return(size);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CRulerTF : public CSearchArray
  {
private:
   CRulerData       *r;
   ENUM_TIMEFRAMES   period;
   long              PS;
   datetime          beg;   // 
   datetime          end;   // 
   datetime TimeBars(int bar){datetime temp[];CopyTime(r.symbol,period,bar,1,temp);return(temp[0]);};
public:
   int               bar;
                     CRulerTF(void){bar=0;period=0;};
                    ~CRulerTF(void){};

   void              Init(CRulerData  *rb){r=rb;};//  
   //---    //  ,
   void              CRulerTFInit(ENUM_TIMEFRAMES period_,datetime beg_,datetime end_);
   //---    
   int               Schift(){return(Bars(r.symbol,period,r.beg,TimeBars(0)));};
   int               Area(){return(size);};    //  
   ENUM_TIMEFRAMES   Period(){return(period);};//  
   //---   
   void              SetPeriod(ENUM_TIMEFRAMES period_){period=period_;};
   //---  
   void              Update(datetime beg_,datetime end_){CRulerTFInit(period,beg_,end_);};
   //---  
   void              Update(ENUM_TIMEFRAMES period_){if(period_!=period)CRulerTFInit(period_,beg,end);};
   int               BarsByTime(datetime time);//    
   //---       
   void              BarsByTime_Set(datetime time){bar=BarsByTime(time);};
   datetime          TimeByBars(int bar);      //    
   datetime          CastToCurr(datetime time);//      
   datetime          NextTime(datetime time);  //   
   datetime          PrevTime(datetime time);  //   

  };
//+------------------------------------------------------------------+
//|   1                                |
//+------------------------------------------------------------------+
void CRulerTF::CRulerTFInit(ENUM_TIMEFRAMES period_,datetime beg_,datetime end_)
  {
   beg=(beg_>=r.end || beg_<=r.beg)?beg_:r.beg;   // 
   end=(end_>=r.end || end_<=r.beg)?end_:r.end;   // 
//---      
   if(beg_==r.beg && end_==r.end)
     {
      if(period_==period)return;//     
      if(period_==PERIOD_M1)//   M1    1
        {
         Resize(r.size);
         for(int i=0;i<size;i++)
           {
            time[i] =r.time[i];
            open[i] =r.open[i];
            high[i] =r.high[i];
            low[i]  =r.low[i];
            close[i]=r.close[i];
           }
         SetPeriod(period_);
         PS=PeriodSeconds(period);
         return;
        }
     }

   SetPeriod(period_);
   PS=PeriodSeconds(period);
   if(period==0){Print("   "+__FUNCTION__);return;}

   if(size!=0)Free();
   int i=r.SearchLessOrEqual(beg),j,tempH,tempL;
   int c=r.SearchLessOrEqual(end);
   int Per=MinuteTF(period);
   while(!IsStopped())//   1   
     {
      if(i>=r.size || i>=c){break;}//   ,          
      long times=r.time[i]/PS*PS;
      if(r.time[i]>=times)//   1     
        {
         size=Resize(size+1);//    
         time[size-1]=(datetime)times;//  
         //---     
         j=1;
         if(i+Per<r.size)//       
           {
            if(r.time[i+Per]==r.time[i]+PS){j=Per;}// ,  
            else//       ,   
              {
               for(j=1;j<=Per;j++)//   
                  if(r.time[i+j]/PS*PS==times+PS)break;//    
              }
            //---  
            open[size-1]=0; high[size-1]=0; low[size-1]=0; close[size-1]=0;//  
            open[size-1]=r.open[i];
            tempH=ArrayMaximum(r.high,i,j); high[size-1]=r.high[tempH];
            tempL=ArrayMinimum(r.high,i,j); low[size-1]=r.low[tempL];
            close[size-1]=r.close[i+j-1];
           }
         i+=j;//       
        }
      else i++;//    1  
     }
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
int CRulerTF::BarsByTime(datetime time_)
  {
   datetime time=(datetime)(time_/PS*PS);
   if(time<beg)return(0);//    
   if(time>end){ return(size-1);}//    
   int res=SearchLessOrEqual(time);
   if(res==-1)BarsByTime(time-PS);
   return(res);
  }
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
datetime CRulerTF::TimeByBars(int bar)
  {
   if(bar<0)return(time[0]);//    
   if(bar>=size)return(time[size-1]);//       
   return(time[bar]);
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+  
datetime CRulerTF::CastToCurr(datetime time)
  {
   return(TimeByBars(BarsByTime(time)));
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
datetime CRulerTF::NextTime(datetime time)
  {
   return(TimeByBars(BarsByTime(time)+1));
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
datetime CRulerTF::PrevTime(datetime time)
  {
   return(TimeByBars(BarsByTime(time)-1));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
