//+------------------------------------------------------------------+
//|                                                  Ind Balance.mq5 |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 19
#property indicator_plots   3
//--- plot hl_equity
#property indicator_label1  "hl_equity"
#property indicator_type1   DRAW_COLOR_CANDLES
#property indicator_color1  C'192,192,192',C'128,128,128'
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot equity
#property indicator_label2  "equity"
#property indicator_type2   DRAW_LINE
#property indicator_color2  C'0,176,0'
#property indicator_style2  STYLE_SOLID
#property indicator_width2  2
//--- plot balance
#property indicator_label3  "balance"
#property indicator_type3   DRAW_LINE
#property indicator_color3  C'0,0,176'
#property indicator_style3  STYLE_SOLID
#property indicator_width3  2
#include "Include\\Balance.mqh" 
CBalance bals_all,bals_sym;
//--- input parameters

double BG=0;long PS;
datetime start_time,end_time;
//--- indicator buffers
double         balanceBuffer[];
double         equityBuffer[];
double         hl_equityBuffer1[];
double         hl_equityBuffer2[];
double         hl_equityBuffer3[];
double         hl_equityBuffer4[];
double         hl_equityBufferColors[];

double         temp_arr[]; //    
datetime       temp_time_[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//bool flag=true; 
int count_rates=0,win_ind=-1;
color bgcolor=0,Color=0,bg=1;
long  chart_id=0;
string name_bg="";//   background
string shortname_all="Ind Balance All",shortname_sym="Ind Balance Sym";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping   
   SetIndexBuffer(0,hl_equityBuffer1,INDICATOR_DATA);
   SetIndexBuffer(1,hl_equityBuffer2,INDICATOR_DATA);
   SetIndexBuffer(2,hl_equityBuffer3,INDICATOR_DATA);
   SetIndexBuffer(3,hl_equityBuffer4,INDICATOR_DATA);
   SetIndexBuffer(4,hl_equityBufferColors,INDICATOR_COLOR_INDEX);
   SetIndexBuffer(5,equityBuffer,INDICATOR_DATA);
   SetIndexBuffer(6,balanceBuffer,INDICATOR_DATA);

   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(5,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   PlotIndexSetDouble(6,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   IndicatorSetString(INDICATOR_SHORTNAME,"Ind Balance");

//---         
   bals_all.ReadFile("All sym");//     
//---         
   if(bals_sym.ReadFile(_Symbol+" sym")<=0)
     {//         
      bals_sym.ReadFile("All sym");
      shortname_sym=shortname_all;
     }
//---           
   PS=PeriodSeconds(_Period);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
//    time    OnChartEvent()   
   count_rates=ArrayCopy(temp_time_,time);
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
   chart_id=lparam;
//        BackGround
   if((int)dparam!=win_ind && dparam!=0.)
     {
      ObjectDelete(chart_id,name_bg);
      win_ind=(int)dparam;
     }
//---         
   bgcolor=(color)ChartGetInteger(chart_id,CHART_COLOR_BACKGROUND);
   if(BG<bgcolor)BG=0;else BG=1;
   ArrayInitialize(hl_equityBufferColors,BG);
//---    All
   if(id==CHARTEVENT_CUSTOM+10203)
     {
      //---           
      start_time=(datetime)(bals_all.array[1].time/PS*PS);
      end_time  =(datetime)(bals_all.array[bals_all.bsize-1].time/PS*PS);
      //---   1   
      Calculate_Balance(GetPointer(bals_all),count_rates,temp_time_);
      //Print("  All");
      IndicatorSetString(INDICATOR_SHORTNAME,shortname_all);
     }
//---    Sym
   if(id==CHARTEVENT_CUSTOM+10204)
     {
      //---          
      start_time=(datetime)(bals_sym.array[1].time/PS*PS);
      end_time=(datetime)(bals_sym.array[bals_sym.bsize-1].time/PS*PS);
      //---   1   
      Calculate_Balance(GetPointer(bals_sym),count_rates,temp_time_);
      //Print("  Sym");
      IndicatorSetString(INDICATOR_SHORTNAME,shortname_sym);
     }
   if(chart_id<=0)return;//     id

   if(BackGroundCreate((int)dparam))UpdateBackGround((int)dparam);
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void Calculate_Balance(CBalance *bal,int rates_total,const datetime &time[])
  {
   int c=1;
   for(int i=0;i<rates_total;i++)
     {
      if(time[i]<start_time || time[i]>end_time)//    
        {
         balanceBuffer[i]   =EMPTY_VALUE;
         equityBuffer[i]    =EMPTY_VALUE;
         hl_equityBuffer1[i]=EMPTY_VALUE;
         hl_equityBuffer2[i]=EMPTY_VALUE;
         hl_equityBuffer3[i]=EMPTY_VALUE;
         hl_equityBuffer4[i]=EMPTY_VALUE;
         if(i>0)
           {
            if(time[i]>end_time && time[i-1]<=end_time)//      
              {//   
               double balance_out=bal.array[bal.bsize-1].balance;
               balanceBuffer[i]   =balance_out;
               equityBuffer[i]    =balance_out;
               hl_equityBuffer1[i]=balance_out;
               hl_equityBuffer2[i]=balance_out;
               hl_equityBuffer3[i]=balance_out;
               hl_equityBuffer4[i]=balance_out;
              }
           }
        }
      else //    
        {
         if(c>bal.bsize-1)continue;
         //        
         int t=0;
         while(bal.array[c+t].time<time[i+1])
           {
            t++;
            if(c+t>bal.bsize-1)
              {
               t--;
               break;
              }
           }
         //     
         balanceBuffer[i]   =bal.array[c+t-1].balance;
         equityBuffer[i]    =bal.array[c+t-1].close;

         //---        
         double inicial=bal.array[c].open;
         ArrayResize(temp_arr,(t+1)*4);
         ArrayInitialize(temp_arr,inicial);
         int k=0;
         for(int j=c;j<c+t;j++)
           {
            temp_arr[k]  = bal.array[j].open;
            temp_arr[k+1]= bal.array[j].bar1;
            temp_arr[k+2]= bal.array[j].bar2;
            temp_arr[k+3]= bal.array[j].close;
            k+=4;
           }
         int max=ArrayMaximum(temp_arr);
         //         
         double High=temp_arr[max>-1?max:0];
         int min=ArrayMinimum(temp_arr);
         //         
         double Low=temp_arr[min>-1?min:0];
         //    ,     
         //       
         hl_equityBuffer1[i]=High;
         hl_equityBuffer2[i]=High;
         hl_equityBuffer3[i]=Low;
         hl_equityBuffer4[i]=Low;
         c+=t;
        }
     }
  }
//+------------------------------------------------------------------+
//|              |
//+------------------------------------------------------------------+
bool BackGroundCreate(int win_ind_)
  {
   name_bg="ind. field BackGround "+ChartSymbol(chart_id);
   if(ObjectFind(chart_id,name_bg)<0)//    
     {//---            
      if(ObjectCreate(chart_id,name_bg,OBJ_RECTANGLE_LABEL,win_ind_,0,0,0,0))
        {//---     
         ObjectSetInteger(chart_id,name_bg,OBJPROP_BACK,0);
         ObjectSetInteger(chart_id,name_bg,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_id,name_bg,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(chart_id,name_bg,OBJPROP_COLOR,bgcolor);
         ObjectSetInteger(chart_id,name_bg,OBJPROP_BGCOLOR,bgcolor);
         ObjectSetInteger(chart_id,name_bg,OBJPROP_BORDER_TYPE,BORDER_FLAT);
         ObjectSetInteger(chart_id,name_bg,OBJPROP_YDISTANCE,0);
        }
      else
        {//---    ,   
         //Print("    "+name_bg+".   ",GetLastError());         
         ResetLastError();
         return(false);
        }
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|    BackGround                           |
//+------------------------------------------------------------------+
void UpdateBackGround(int win_ind_)
  {
//---   ,   
   int schift_size_pips;
   int scale=(int)ChartGetInteger(chart_id,CHART_SCALE);
   double pointer_per_bar=pow(2,scale);
   bool chart_schift=(bool)ChartGetInteger(chart_id,CHART_SHIFT);
   double schift_size=ChartGetDouble(chart_id,CHART_SHIFT_SIZE);
   int width_in_pixels=(int)ChartGetInteger(chart_id,CHART_WIDTH_IN_PIXELS,win_ind_);//  
   int height_in_pixels=(int)ChartGetInteger(chart_id,CHART_HEIGHT_IN_PIXELS,win_ind_);// 
   if(chart_schift)
      schift_size_pips=(int)(width_in_pixels*(1.-schift_size*0.01)+pointer_per_bar/2);
   else
      schift_size_pips=(int)(width_in_pixels-pointer_per_bar);
//---        
   if(Color!=bgcolor)
     {
      Color=bgcolor;
      ObjectSetInteger(chart_id,name_bg,OBJPROP_COLOR,bgcolor);
      ObjectSetInteger(chart_id,name_bg,OBJPROP_BGCOLOR,bgcolor);
     }
   ObjectSetInteger(chart_id,name_bg,OBJPROP_XDISTANCE,schift_size_pips);
   ObjectSetInteger(chart_id,name_bg,OBJPROP_XSIZE,schift_size_pips*2);
   ObjectSetInteger(chart_id,name_bg,OBJPROP_YSIZE,height_in_pixels*3);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
